package be.iminds.ilabt.jfed.experimenter_gui.dialogs;

import be.iminds.ilabt.jfed.espec.bundle.ESpecBundle;
import be.iminds.ilabt.jfed.experiment.ExperimentController;
import be.iminds.ilabt.jfed.highlevel.jobs.TestLinksJob;
import be.iminds.ilabt.jfed.rspec.rspec_source.RequestRspecSource;
import javafx.stage.Window;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

/**
 * User: twalcari
 * Date: 1/12/2015
 * Time: 14:10
 */
public interface DialogsFactory {
    void showCreateSliceDialog(@Nullable Window parentWindow, @Nonnull RequestRspecSource requestRspecSource);
    void showCreateSliceDialog(@Nullable Window parentWindow, @Nonnull ESpecBundle experimentSpecificationBundle);

    void showRebootDialog(@Nullable Window parentWindow, @Nonnull ExperimentController experimentController);

    void showEditSshKeysDialog(@Nullable Window parentWindow, @Nonnull ExperimentController experimentController);

    void showShareSliceDialog(@Nullable Window parentWindow,  @Nonnull ExperimentController experimentController);
    void showUnshareSliceDialog(@Nullable Window parentWindow,  @Nonnull ExperimentController experimentController);

    void showCreateReservationDialog(@Nullable Window parentWindow, @Nonnull RequestRspecSource requestRspecSource);

    void showRenewSliceDialog(@Nullable Window parentWindow, @Nonnull ExperimentController experimentController);

    void showTerminateSliceDialog(@Nullable Window parentWindow, @Nonnull ExperimentController experimentController);

    void showLinkTestDialog(@Nullable Window parentWindow, @Nonnull List<TestLinksJob.LinkTestReport> reports);
}
